%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% This program evaluates the performance of the optimal 
% policy for a multihop fast fading EH
% link in the special case
%
% Author: Mohit K. Sharma
% Email: mohit.sharma987@gmail.com
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all 
close all 
NumPkt 	 	    = 	1e7;                                        % no of packets
rho1 			= 	0.05:0.05:1;                                     % probability of energy harvesting at transmitter
rho2            =   0.6;
Es_db			=   3;   % 8 dB corresponds to 200 microJoule  Energy harvested per slot 
Es 			    =   10^(Es_db/10);                                  % Energy harvested per slot
B1              =   200*Es;                                                     % battery capacity
B2              =   200*Es;
B3              =   50*Es;
K 			    = 	4;                                                         % Max no of slots
Tp              =   1;                                                        % Packet Duration
R               =   1;
Lmax            =   10*Es; 
epsilon         =   1e-5;
K1              =   K;
K2              =   K;



for rhot = rho1                                        % Loop is running for all  rho values
       
        rhoidt 		= 	find(rhot == rho1)
       
        hprocess1 	= 	(rand(1,NumPkt*(K1+K2)) <= rhot)*Es;
    for rhor = rho2  
        
        rhoidr 		= 	find(rhor == rho2);
        hprocess2 	= 	(rand(1,NumPkt*(K1+K2)) <= rhor)*Es;
        %hprocess3 	= 	(rand(1,NumPkt*(K1+K2)) <= rho3)*Es;
        BT1         = 	50*Es;  BT2  =   50*Es; %BT3 = 50*Es; BTR1= 50*Es; BTR2 = 50*Es; BTR3 =50*Es; 
        
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% POLICY COMPUTATION %%%%%%%%%%%%%%
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       
       for hc=1:2
           
           if (hc==1)
                  Prn = 1;
                  Kp=K1;
                  Eav= (K1+K2)*rhot*Es-0.02;
                  m=0;  ell=0; err=1; err1=1;
                  Kp_new=Kp;
                  Eav_new=Eav;
                  C=Eav+1;
                  L=C*(2^(K-1))/(2*(2^K-1));
                  fk=2*(K-2)/(C-K+5);
                  E1(1) = L*(1+sqrt(1+fk/(L^2*(2^K-1))))-1;
                  f=0;
                   while ((err>1e-10)&&(err>0))
                            E1(1) =E1(1)+1e-4;  
                            E1(2) = E1(1)*(E1(1)+2)/2;
                            E1(3) = E1(2)*(E1(2)+2)/2;
                            E1(4) = E1(3)*(E1(3)+2)/2;
                            err = Eav-(E1(1)+(E1(2)/(1+E1(1)))+(E1(3)/((1+E1(1))*(1+E1(2))))+(E1(4)/((1+E1(1))*(1+E1(2))*(1+E1(3)))));
                      f=f+1;     
                   end
                  E1(1)=E1(1)-1e-4;
                  Ea=E1(1);
                if(E1(1)>=Lmax)
                    E1 =[Lmax Lmax Lmax Lmax];
                    err1 =0;
                else
                  while (err1>1e-10)
                       ell=ell+1;
                            for i=2:Kp_new
                           
                                 E1(i) = min(E1(i-1)*(E1(i-1)+2)/2,Lmax);
                        
                                   if (E1(i)==Lmax)
                                         m=m+1;
                                   else
                                       Ea=Ea+E1(i);
                                   end
                         
                            end
                    
                              if ((m==0)||(m==4))
                                                    err1=0;
                              else
                                             t = fzero(@(t)myfun_ff(t,Kp,m,Lmax,Eav),Eav );
                                             E1(1)= t;
                                            err1 = Eav-(E1(1)+(E1(2)/(1+E1(1)))+(E1(3)/((1+E1(1))*(1+E1(2))))+(E1(4)/((1+E1(1))*(1+E1(2))*(1+E1(3))))); 
                                            Kp_new=Kp-m;
                              end
                  end
                end
           else 
                  Prn = 1-(1/((1+E1(1))*(1+E1(2))*(1+E1(3))*(1+E1(4))));
                  Kp=K2;
                  Eav= ((K1+K2)*rhor*Es/Prn)-0.05;
                  m=0; Ea=0; ell=0; err2=1;
                  Kp_new =Kp;
                  Eav_new=Eav;
                  C=Eav+1;
                  L=C*(2^(K-1))/(2*(2^K-1));
                  fk=2*(K-2)/(C-K+5);
                  E2(1) = L*(1+sqrt(1+fk/(L^2*(2^K-1))))-1;
                  f=0;
                  if(E2(1)>=Lmax)
                      E2=[Lmax Lmax Lmax Lmax];
                      err2=0;
                  else 
                   while ((err>1e-10)&&(err>0))
                            E2(1) = E2(1)+1e-4;  
                            E2(2) = E2(1)*(E2(1)+2)/2;
                            E2(3) = E2(2)*(E2(2)+2)/2;
                            E2(4) = E2(3)*(E2(3)+2)/2;
                            err = Eav-(E2(1)+(E2(2)/(1+E2(1)))+(E2(3)/((1+E2(1))*(1+E2(2))))+(E2(4)/((1+E2(1))*(1+E2(2))*(1+E2(3)))));
                      f=f+1;     
                   end
                  E2(1)=E2(1)-1e-4;
                  while (err2>1e-5)
                        ell=ell+1;
                          m1=0;  
                        for i=2:Kp_new
                           
                                 E2(i) = min(E2(i-1)*(E2(i-1)+2)/2,Lmax);
                                       
                                 
                                 
                                   if (E2(i)==Lmax)
                                         m=m+1;
                                         m1=m1+1;
                                   else
                                       Ea=Ea+E2(i);
                                   end

                        end
                        
                         
                             if ((m1==0)||(m1==4))
                                         err2=0; 
                             else
                                            t = fzero(@(t)myfun_ff(t,Kp,m,Lmax,Eav),Eav);
                                            E2(1)= t;
                                             err2 = Eav-(E2(1)+(E2(2)/(1+E2(1)))+(E2(3)/((1+E2(1))*(1+E2(2))))+(E2(4)/((1+E2(1))*(1+E2(2))*(1+E2(3)))));
                                             Kp_new=Kp-m;
                             end 
                              
                 end 
                  end   
           end
    
       end
              
       
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  E_diff1 =(K1+K2)*rhot*Es - (E1(1)+ (E1(2)/(1+E1(1)))+(E1(3)/((1+E1(1))*(1+E1(2))))+(E1(4)/((1+E1(1))*(1+E1(2))*(1+E1(3)))))          
  E_diff2 =(K1+K2)*rhor*Es/Prn - (E2(1)+ (E2(2)/(1+E2(1)))+(E2(3)/((1+E2(1))*(1+E2(2))))+(E2(4)/((1+E2(1))*(1+E2(2))*(1+E2(3)))))
%err1
%err2
 Lvec1 =  E1
 Lvec2 =  E2
 
        NumAck(rhoidt,rhoidr)	= 	0;
        NumAck1(rhoidt,rhoidr)	= 	0;
       ell(rhoidt)=0;
 for pac= 1:NumPkt
     ACK1 	= 	0; ACK2=0;  %ACKR1=0; ACKR2=0;
     
     i=0; ir=0;
     for kk = 0:K1-1                                              % Loop is running for a frame
		BT1  =   min(BT1+hprocess1((pac-1)*(K1+K2)+kk+1),B1);
        BT2  =   min(BT2+hprocess2((pac-1)*(K1+K2)+kk+1),B2);
        gamma1 	= 	exprnd(1);
        %BT3  =   min(BT3+hprocess3((pac-1)*(K1+K2)+kk+1),B3);
%         BTR1 =   min(BTR1+hprocess1((pac-1)*(K1+K2)+kk+1),B1);
%         BTR2 =   min(BTR2+hprocess2((pac-1)*(K1+K2)+kk+1),B2);
%         BTR3 =   min(BTR3+hprocess3((pac-1)*(K1+K2)+kk+1),B3);
			if ((BT1 >=Lvec1(i+1)) && (ACK1 == 0))
				BT1 	= 	BT1 - Lvec1(i+1);
                %BT2     =   BT2-R2;                
                %sk=sk+(Lvec(i+1)*gamma);
                Pe = exp(-(gamma1*Lvec1(i+1)/Tp));
                ACK1 = (Pe<=rand(1,1));
                i=i+1;
                %ell=ell+1;
				%ACK 	= 	(rand(1,1) >= Pe);
            end
     end
     i=0; %ir=0;
     
    for kk=0:K2-1
        BT1  =   min(BT1+hprocess1((pac-1)*(K1+K2)+K1+kk+1),B1);
        BT2  =   min(BT2+hprocess2((pac-1)*(K1+K2)+K1+kk+1),B2);
        gamma2 	= 	exprnd(1);
%        BT3  =   min(BT3+hprocess3((pac-1)*(K1+K2)+K1+kk+1),B3);
%         BTR1 =   min(BTR1+hprocess1((pac-1)*(K1+K2)+K1+kk+1),B1);
%         BTR2 =   min(BTR2+hprocess2((pac-1)*(K1+K2)+K1+kk+1),B2);
%         BTR3 =   min(BTR3+hprocess3((pac-1)*(K1+K2)+K1+kk+1),B3);
             if ((BT2 >=Lvec2(i+1)) && (ACK1 == 1) && (ACK2==0) )
				BT2 	= 	BT2 - Lvec2(i+1);
                %BT3     =   BT3-R3;                
                %sk=sk+(Lvec(i+1)*gamma);
                Pe = exp(-(gamma2*Lvec2(i+1)/Tp));
                ACK2 = (Pe<=rand(1,1));
                i=i+1;
				%ACK 	= 	(rand(1,1) >= Pe);
    end

    end
    
       NumAck(rhoidt,rhoidr)	= 	NumAck(rhoidt,rhoidr) + ACK2;
       NumAck1(rhoidt,rhoidr)	= 	NumAck1(rhoidt,rhoidr) + ACK1;
 
 end
 NumAck;
 NumAck1;
 
    end
end
Out = ones(length(rho1),length(rho2)) -NumAck/NumPkt;    % calculating the outage probability prob of success =  total no of ACK / Total no of packets.
Out2= ones(length(rho1),length(rho2))- NumAck./NumAck1;
fname = ['mat/Multihop_barq_ff_splcase_Es_',num2str(Es_db),'_pmax_',num2str(Lmax),'_rho2_',num2str(rhor),'_K1_',num2str(K1),'_K2_',num2str(K2),'quantz',datestr(now,'mmmm_dd_yy_HH_MM_SS'),'.mat'];
eval(['save ', fname,' rho2 Out Out2']);